% set up the parameters
h = .1;
x0 = [pi/2, 0]';
nsteps = 200;
len = 5;
g = 9.8;
m = 1;
rho = 0;
params = [rho/m,g/len];

X = zeros(2,nsteps);
X(:,1) = x0;

T = zeros(1,nsteps);
U = zeros(1,nsteps);

for i=1:nsteps-1
  fprintf('Step: %03d, time: %3.2f     \r',i, h*i);
  
  subplot(2,2,1);
  title('phase plot')
  % TODO: render the phase plot
  % label the axes with xlabel/ylabel; put a title on it
  drawnow
  
  subplot(2,2,2,'replace');
  title('pendulum')
  % TODO: draw the phase plot
  drawnow
  
  subplot(2,2,3);
  % TODO: plot the energy up to now
  % label the axes and put a legend
  
  
  % update the state
  X(:,i+1) = odestep(X(:,i),@pend,h,'rk4',params);

  % recenter the phase
  if X(1,i+1) > pi
    X(1,i+1) = X(1,i+1) - 2*pi;
  end
  
  if X(1,i+1) < -pi
    X(1,i+1) = X(1,i+1) + 2*pi;
  end
end